unit dwsDemoLib;

interface

uses
  SysUtils, Classes, dwsComp;

type
  TdwsDemoLib = class(TdwsLib)
  protected
  	procedure AddFunctions; override;
  end;

  TdmoCreateFunc = class (TFunction) function Evaluate (argpat : Integer; args : TList) : Variant; override; end;
  TdmoValueFunc = class (TFunction) function Evaluate (argpat : Integer; args : TList) : Variant; override; end;
  TdmoIncFunc = class (TFunction) function Evaluate (argpat : Integer; args : TList) : Variant; override; end;
  TdmoIncByValueFunc = class (TFunction) function Evaluate (argpat : Integer; args : TList) : Variant; override; end;

procedure Register;

implementation

procedure Register;
begin
	RegisterComponents ('DWS', [TdwsDemoLib]);
end;

type
	TdmoObj = class (TdwsObject)
		value : Integer;
    constructor Create;
	end;

constructor TdmoObj.Create;
begin
  AutoDestroy := True;
end;

function GetObj (script : TDelphiWebScript; expr : TExpr) : TdmoObj;
begin
	result := TdmoObj (script.GetObj (TExpr (expr).Eval));
end;

{ TdwsStringsLib }

procedure TdwsDemoLib.AddFunctions;
var
	f : TFunction;
begin
	AddF (TdmoCreateFunc.CreateArg ('dmoCreate', atInteger, []));
	f := AddF (TdmoValueFunc.CreateArg ('dmoValue', atInteger, [atInteger]));
  f.AddArgs ([atInteger, atInteger]);
	AddF (TdmoIncFunc.CreateArg ('dmoInc', atVoid, [atInteger]));
	AddF (TdmoIncByValueFunc.CreateArg ('dmoIncByValue', atVoid, [atInteger, atInteger]));
end;

{ TdmoCreateFunc }

function TdmoCreateFunc.Evaluate(argpat: Integer; args: TList): Variant;
begin
  result := funcScript.NewObj (TdmoObj.Create);
end;

{ TdmoValueFunc }

function TdmoValueFunc.Evaluate(argpat: Integer; args: TList): Variant;
begin
  if argpat = 0 then
    result := GetObj (funcScript, args[0]).value
  else if argpat = 1 then begin
    result := 0;
    GetObj (funcScript, args[0]).value := TExpr (args[1]).Eval;
  end;
end;

{ TdmoIncFunc }

function TdmoIncFunc.Evaluate(argpat: Integer; args: TList): Variant;
begin
  Inc (GetObj (funcScript, args[0]).value);
end;

{ TdmoIncByValueFunc }

function TdmoIncByValueFunc.Evaluate(argpat: Integer;
  args: TList): Variant;
begin
  Inc (GetObj (funcScript, args[0]).value, Integer (TExpr (args[1]).Eval));
end;

{ TdmoObj }

end.

